<template>
  <v-dialog
    v-model="isOpen"
    max-width="800px"
    :fullscreen="$vuetify.breakpoint.xsOnly"
    :transition="$vuetify.breakpoint.xsOnly ? 'dialog-bottom-transition' : 'dialog-transition'"
  >
    <v-card v-if="!uploadstats.uploading" :tile="$vuetify.breakpoint.smAndDown">
      <v-card-title>
        {{ $t('courses.files.upload.upload_file') }}

        <v-spacer />

        <!-- Close -->
        <v-btn icon @click="isOpen = false">
          <v-icon>mdi-close</v-icon>
        </v-btn>
      </v-card-title>
      <!-- Content -->
      <v-card-content>
        <!-- Form -->
        <v-form ref="form" :disabled="uploadMutation.loading.value" lazy-validation>
          <v-row>
            <!-- Select file -->
            <v-col cols="12">
              <v-file-upload v-model="fields.files" />
            </v-col>
          </v-row>
          <v-row v-if="!fields.files || fields.files.length <= 1">
            <!-- Name -->
            <v-col cols="12">
              <v-text-field
                v-model="fields.name"
                :rules="rules.name"
                class="studium-input"
                hide-details="auto"
                :label="$t('courses.files.upload.name_label')"
                color="primary"
                :hint="$t('courses.files.upload.hint')"
                outlined
              />
            </v-col>
          </v-row>

          <v-row v-else>
            <!-- Multiple Information -->
            <v-col cols="12">
              <span>{{ $t('courses.files.upload.multiple_files') }}</span>
            </v-col>
          </v-row>

          <v-row>
            <!-- Category -->
            <v-col cols="12">
              <v-select
                v-model="fields.category"
                :rules="rules.category"
                :items="tags"
                class="studium-input"
                hide-details="auto"
                value="name"
                item-text="name"
                :label="$t('courses.files.upload.category_label')"
                color="primary"
                outlined
                required
                :menu-props="{ 'offset-y': true, 'offset-overflow': true }"
              />
            </v-col>
          </v-row>

          <v-row>
            <!-- Anonymous -->
            <v-col cols="12">
              <v-checkbox
                v-model="fields.anonymous"
                class="mt-0"
                :label="$t('courses.files.upload.anonymous_label')"
                hide-details="auto"
                :hint="$t('courses.files.upload.anonymous_hint')"
                persistent-hint
                color="primary"
                dense
              />
              <span class="v-messages orange--text">
                <v-icon x-small color="orange"> mdi-alert-circle-outline </v-icon>

                {{ $t('courses.files.upload.anonymous_info') }}
              </span>
            </v-col>
          </v-row>
        </v-form>
      </v-card-content>

      <!-- Actions -->
      <v-card-actions>
        <v-spacer />

        <!-- Upload -->
        <v-tooltip bottom :disabled="!!fields.files">
          <template #activator="{ on, attrs }">
            <div v-bind="attrs" v-on="on">
              <v-btn
                class="studium-button"
                color="primary"
                text
                large
                :ripple="false"
                :loading="uploadMutation.loading.value"
                :disabled="!!fields.files && fields.category === ''"
                @click="submit"
              >
                {{ $t('courses.files.upload.upload') }}
              </v-btn>
            </div>
          </template>

          <!-- Tell the user they need to select a file to continue -->
          <span> {{ $t('courses.files.upload.select') }} </span>
        </v-tooltip>

        <!-- Cancel -->
        <v-btn class="studium-button" color="secondary" text large :ripple="false" @click="isOpen = false">
          {{ $t('courses.files.upload.cancel') }}
        </v-btn>
      </v-card-actions>
    </v-card>

    <!-- Uploading file(s) -->
    <v-card v-if="uploadstats.uploading" :tile="$vuetify.breakpoint.smAndDown">
      <v-card-title v-if="uploadstats.completed.length + uploadstats.failed.length != uploadstats.amount">
        {{ $t('courses.files.upload.uploading') }} {{ uploadstats.completed.length }}/{{ uploadstats.amount }}
      </v-card-title>

      <!-- Done uploading file(s) -->
      <div v-else>
        <v-card-title>
          {{ $t('courses.files.upload.upload_comp') }} {{ uploadstats.completed.length }}
          {{ $t('courses.files.upload.files') }}
        </v-card-title>
        <v-card-title v-if="uploadstats.failed.length">
          {{ $t('courses.files.upload.error_upload') }}{{ uploadstats.failed.length }}
          {{ $t('courses.files.upload.files') }}
        </v-card-title>
        <div style="max-height: 400px" class="overflow-y-auto">
          <v-list disabled>
            <v-list-item-group v-model="uploadstats.failed.length">
              <v-list-item v-for="(errorfile, i) in uploadstats.failed" :key="i">
                <v-list-item-content>
                  <v-list-item-title>{{ errorfile.filename }}</v-list-item-title>
                  <v-list-item-subtitle>{{ errorfile.error }}</v-list-item-subtitle>
                </v-list-item-content>
              </v-list-item>
            </v-list-item-group>
          </v-list>
        </div>
      </div>
      <v-card-actions>
        <v-spacer />
        <v-btn class="studium-button" right color="primary" text large :ripple="false" @click="isOpen = false">
          {{ $t('courses.files.upload.done') }}
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script lang="ts">
import { defineComponent, reactive, ref } from '@nuxtjs/composition-api'
import { useVModel } from '@vueuse/core'

import { CourseDocumentsDocument, useUploadDocumentMutation } from '~/apollo/_generated'
import { useErrorHandler } from '~/util/composables'

export default defineComponent({
  props: {
    // Synchronised property if the dialog is open
    open: {
      type: Boolean,
      default: false,
    },

    // Course Code
    courseCode: {
      type: String,
      required: true,
    },

    // Tags
    tags: {
      type: Array,
      required: true,
    },
  },
  setup(props, { emit }) {
    const isOpen = useVModel(props, 'open', emit)

    // Form element binding
    const form = ref()

    // Form fields
    const fields = reactive({
      file: null,
      files: [],
      failed: [],
      name: '',
      category: '',
      anonymous: false,
    })

    const uploadstats = reactive({
      failed: [] as Object[],
      completed: [] as File[],
      files: [],
      amount: 0,
      uploading: false,
    })

    // Form rules
    const rules = {
      name: [
        // Required
        (v) => !!v || 'Name is required',
        // Length
        (v) => (v && v.length <= 50) || 'Name cannot be larger than 50 characters',
        (v) => (v && v.length >= 6) || 'Name must be at least 6 characters',
      ],
      category: [
        // Required
        (v) => !!v || 'Category is required',
      ],
    }

    // Upload mutation
    const uploadMutation = useUploadDocumentMutation({
      update: (cache, { data: uploadData }) => {
        // Fetch the list with documents for the course from the cache
        const data: any = cache.readQuery({
          query: CourseDocumentsDocument,
          variables: { code: props.courseCode },
        })

        // Add the uploaded document to the list
        data.courseByCode.documents.edges.push({
          node: uploadData?.uploadDocument?.document,
          __typename: 'DocumentTypeEdge',
        })

        // Update the cache
        cache.writeQuery({ query: CourseDocumentsDocument, data })
      },
    })
    const uploadMutationError = useErrorHandler(uploadMutation)

    // Add listeners for success and a error
    uploadMutation.onDone(() => {
      if (uploadstats.files.length) {
        const newfile: File = Array.prototype.pop.call(uploadstats.files)
        uploadstats.completed.push(newfile)
        handleUploads()
      }
    })

    uploadMutation.onError((error) => {
      if (uploadstats.files.length) {
        const newfile: File = Array.prototype.pop.call(uploadstats.files)
        const errormessage = uploadMutationError.value ? uploadMutationError.value.message : error.message
        const errorObject: { filename: String; error: String } = {
          filename: newfile.name,
          error: errormessage,
        }
        uploadstats.failed.push(errorObject)
        handleUploads()
      }
    })

    // Recursive function that gets called for the next file with the succession or failure of a previous
    function handleUploads() {
      if (uploadstats.files.length) {
        const newfile: File = uploadstats.files[uploadstats.files.length - 1]
        const matches = newfile.name.match(/(.*)\.[^.]+$/)
        const filename = matches ? matches[1] : newfile.name

        uploadMutation.mutate({
          courseCode: props.courseCode,
          file: newfile,
          name: uploadstats.amount === 1 ? fields.name : filename,
          tags: [fields.category],
          anonymous: fields.anonymous,
        })
      }
    }

    // Submit action
    function submit() {
      uploadstats.files = fields.files
      uploadstats.amount = fields.files.length
      uploadstats.uploading = true
      handleUploads()
    }

    return {
      isOpen,
      form,
      fields,
      uploadstats,
      rules,
      uploadMutation,
      uploadMutationError,
      submit,
    }
  },
})
</script>
